package com.company.example.entity;

import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.Column;
import jakarta.persistence.MappedSuperclass;
import jakarta.validation.constraints.NotNull;

@JmixEntity(name = "trz_BasicField")
@MappedSuperclass
public abstract class BasicField extends Tenant {

    @Column(name = "IDENTIFICATION", nullable = false, length = 40)
    @NotNull
    private String identification;

    @InstanceName
    @Column(name = "NAME_", nullable = false)
    @NotNull
    private String name;

    @Column(name = "HIDDEN")
    private Boolean hidden = false;

    public String getIdentification() {
        return identification;
    }

    public void setIdentification(String identification) {
        this.identification = identification;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Boolean getHidden() {
        return hidden;
    }

    public void setHidden(Boolean hidden) {
        this.hidden = hidden;
    }
}